// Aufruf Lokal | Vienna 11.08.2008
//
// Flugzeug erstellen. Einmaliger Anflug aufs Ziel.
// Feuern auf den Laserpunkt des LaserMarkers.
// 
// Westseite wird automaitsch mit "AV8B" angeflogen, Ostseite mit "Su34".
//
// Aufruf nur ber Aktionsmenpunkt!
// Parameter in der Aktion: ["<LasermarkerBezeichnung>",<Reichweite des Laserpunktes>]
// Aufrufbeispiel siehe im Skript "LaserInAktion.sqf"


// lokale Variable
	private ["_p","_z","_a","_s","_t","_xy1","_h","_eh","_d","_g","_e1","_e2","_e3","_f","_w","_wp","_m"];

// _p: Array mit LaserMarker 
  _p = player nearObjects[(_this select 3)select 0,(_this select 3)select 1];
	if (count _p == 0) exitWith {player groupChat "LaserMarker nicht eingeschalten!"};
	
//globale Variable beim ersten Aufruf fr Bestimmung des Anflugorts initialisieren.
	if (isNil "ViennasLaserAnflugRichtung") then {ViennasLaserAnflugRichtung = floor(random 4)};

// diese globale Variable zeigt an, dass ein Flugzeug im Einsatz ist
	ViennaLaserAirEinsatz = true;


// 1) Flugzeug erstellen ///////////////////////////////////
////////////////////////////////////////////////////////////

// _p: Anflugposition 
  _p = getPos (_p select 0);
// _z: Logik-Objekt auf Zielposition
	_z = "Logic" createVehicleLocal _p;
// Seehhe des Ziels
	_a = getPosASL _z select 2;
// _s: Seite des Spielers
	_s = playerSide;
// _t: 3 Minuten Notausstieg aus Skript
	_t = time + 180;

// _w: Anflughhe
	_w = 400;
// _xy1: Anflugposition von N, E, S oder W
	ViennasLaserAnflugRichtung = ViennasLaserAnflugRichtung + 1; if (ViennasLaserAnflugRichtung > 3) then {ViennasLaserAnflugRichtung = 0};
	_xy1 = [[_p select 0,(_p select 1)+4000],[(_p select 0)+5000,_p select 1],[_p select 0,(_p select 1)-6000],[(_p select 0)-5000,_p select 1]];
			
// _h: Flug Objekt
	_h = createVehicle [if(_s == WEST)then{"AV8B"}else{"Su34"},_xy1 select ViennasLaserAnflugRichtung,[],500,"FLY"];
	_h setPos [getPos _h select 0,getPos _h select 1,_w+_a];
	{_h removeMagazine _x} forEach magazines _h;
	{_h removeWeapon   _x} forEach weapons   _h;
// _eh: EventHandler ID	
	_eh = _h addEventHandler ["Fired",
		{
			LaserBombenAbgeworfen = LaserBombenAbgeworfen +1;
			player groupChat format["Abwurf (%1) erfolgt!",LaserBombenAbgeworfen]
		}];
	LaserBombenAbgeworfen = 0; //Globale Variable enthlt Anzahl der abgeworfenen Bomben

// _d: Pilot
	_d = createGroup _s createUnit [if(_s == WEST)then{"SoldierWPilot"}else{"SoldierEPilot"}, [0,0], [], 0, "FORM"];
	_d setBehaviour "careless";
	_d allowFleeing 0;
	_d setCombatMode "BLUE";
	_d moveInDriver _h;
// _g: Schtze fr die SU	
	if (_s==EAST) then 
		{
			_g = group _d createUnit ["SoldierEPilot", [0,0], [], 0, "FORM"];
			_g setBehaviour "careless";
			_g allowFleeing 0;
			_g moveInGunner _h
		};


// 2) Flugzeug fliegt zum LaserMarker und startet Angriff darauf ////
/////////////////////////////////////////////////////////////////////

player groupChat "Kampfflieger im Anflug! LaserMarker eingeschaltet lassen!";

// _e1,_e2,_e3: Steuervariable 
	_e1 = true;  //true=Flugzeug im Anflug, false=Flugzeug hat Ziel bereits berflogen
	_e2 = 0;     //Steuert Entfernungs- und Aktionsabfragen
	_e3 = 10000; //Wert zeigt an, ob Flugzeug vor dem Ziel

// Hauptschleife
	// _wp: fr Wegpunkthandhabung
	_wp = group _d addWaypoint [_p,0]; group _d setCurrentWaypoint [group _d, 1];
	_h flyinHeight (_w+_a);
	_h setspeedMode "NORMAL";
	while {_e1 AND alive _h AND time < _t} do 
		{
			// _f: Entfernung zum Ziel
			_f = _h distance _z;
			hint format["***** ANFLUGINFORMATION *****\n\nEntfernung zum Ziel: %1 m\nGeschwindigkeit: %2 km/h\nFlugrichtung: %3 Grad\nBodenabstand: %4 m",floor(_h distance _z),floor(speed _h),floor(getDir _h),floor(getPos _h select 2)];
			//---> Nur fr Testzwecke: hint format["Bomber Entfernung zum Ziel: %1\nFlugrichtung: %2 Grad\nBodenabstand beim Flug: %3\n\nZielort-Seehoehe: %4\nFlieger-Seehoehe: %5\n\nAbstand Ziel zu Flugzeug\nX: %6    Y: %7\n\nVerbleibende Zeit: %8 sek\n\nAbstand _e3 zu _f: %9",floor(_h distance _z),floor(getDir _h),floor(getPos _h select 2),floor _a, floor(getPosASL _h select 2),floor abs((getpos _z select 0)-(getpos _h select 0)),floor abs((getpos _z select 1)-(getpos _h select 1)),floor(_t-time)];
			//Laserpunkt Anvisieren einschalten?
			if (_f < 2500) then 
				{
					//Flughhe und Geschwindigkeit verringern
					if (_e2 == 0) then {_e2=1;_h flyinHeight(_w/2+_a);_h setspeedMode "LIMITED"};
					//Angriff auf LaserMarker starten
					if (_e2 == 1) then 
						{
							_m = player nearObjects[(_this select 3)select 0,(_this select 3)select 1]; //LaserMarker suchen
							if (count _m > 0) then //Lasermarker gefunden
								{
									if (_s == WEST) then
										{
											//Waffen fr WEST (nur fr Flugzeug AV8B mglich)
											_h addMagazine "6Rnd_GBU12_AV8B";
											_h addWeapon   "BombLauncher"
										}
									else
										{
											//Waffen fr EAST (East hat keine eigenen Waffen um Laserpunkt genau zu treffen)
											_h addMagazine "8Rnd_Hellfire";
											_h addWeapon   "HellfireLauncher"
										};
									_h setCombatMode "YELLOW";
									_h doTarget (_m select 0);
									sleep 0.1;
									_h doFire (_m select 0);
									_e2 = 2;
									player groupChat "Starte Angriff auf den LaserMarker! Laserpunkt auf dem Ziel halten!"
								}
						};
					//Flugzeug vor oder nach dem Ziel? Nach dem Ziel = Ende
					if (_e2 > 0) then
						{
							if (_e3 >= _f) then {_e3=_f} else {_e1=false}
						};
				};
			sleep 0.01
		};


// 3) Zielanflug beendet. Meldung ob Angriff erfolgt. /////////
///////////////////////////////////////////////////////////////

if (LaserBombenAbgeworfen > 0) then
	{
		hint format["Einsatz nach %1mal Bombenabwurf beendet!\n\nDie neue Einsatzbereitschaft des Kampfjets wird gemeldet!",LaserBombenAbgeworfen]
	}
else
	{
		hint "Einsatz beendet! Keine ausreichende Sicht auf den Laserpunkt!\n\nAnforderung wiederholen! Anflug erfolgt aus anderer Richtung!\n\nDie neue Einsatzbereitschaft des Kampfjets wird gemeldet!"
	};

//---> Nur fr Testzwecke: hint format["Bomber Entfernung zum Ziel: %1\nFlugrichtung: %2 Grad\nBodenabstand beim Flug: %3\n\nZielort-Seehoehe: %4\nFlieger-Seehoehe: %5\n\nAbstand Ziel zu Flugzeug\nX: %6    Y: %7\n\nVerbleibende Zeit: %8 sek\n\nAbstand _e3 zu _f: %9",floor(_h distance _z),floor(getDir _h),floor(getPos _h select 2),floor _a, floor(getPosASL _h select 2),floor abs((getpos _z select 0)-(getpos _h select 0)),floor abs((getpos _z select 1)-(getpos _h select 1)),floor(_t-time)];

//Pilot Abfliegen und alle Wegpunkte lschen	
	for [{_wp = Count Waypoints _d},{_wp>=0},{_wp=_wp-1}] do {deleteWaypoint[group _d,_wp]};
	_h setCombatMode "BLUE";
	_h flyinHeight 800;
	_h setspeedMode "FULL";
	_h removeEventHandler ["Fired", _eh];
	
//Spieler LaserMarker absetzen
	sleep 3;
	player selectWeapon primaryWeapon player;

//neue Anforderung zulassen
	sleep 30;
	player groupChat "**** Kampfflugzeug zu neuem Laser-Airstrike einsatzbereit! ****";
	if (LaserBombenAbgeworfen == 0) then {hint "Kampfjet bereit zu neuem Anflug"; sleep 3};
	ViennaLaserAirEinsatz = false;


// 4) Objekte lschen //////////////////////////////////////
////////////////////////////////////////////////////////////
	_t = time + 80;
	waitUntil {_h distance _z > 2000 OR time > _t};
	deleteVehicle _d;
	deleteVehicle _g;
	deleteVehicle _h;
	deleteVehicle _z
